;;;-----------> ASSEMBL.LSP <------------------------------------------
;;;        version 1.1 -26/04/2001
;;;   
;;;
;;;Copyright  \"SingleSoft PG\" "
;;;mailto:gepos@mail.ru  cadhlp@kulichki.com
;;; 
;;; 
;;;
;;;-------------> HELP <---------------------------------------------
(defun ab_prog (ab_progr /)

  (if (not (new_dialog "ab_text" DCL_ID))
    (exit)
  )
  (start_list "ab_progr")
  (mapcar 'add_list ab_progr)
  (end_list)

  (action_tile "accept" "(done_dialog)")
  (start_dialog)
)
;;;--------------------------------------------------------------------------
(defun im_b1 (f_color /)
  (setq	x2 (dimx_tile "b-1")   y2 (dimy_tile "b-1") )
  (start_image "b-1")
  (fill_image 0 0 x2 y2 f_color)   (slide_image 0 0 x2 y2 "assembl(bolt)")
  (end_image)
)
;;;--------------------------------------------------------------------------
(defun im_b2 (f_color /)
  (setq	x2 (dimx_tile "b-2")   y2 (dimy_tile "b-2") )
  (start_image "b-2")
  (fill_image 0 0 x2 y2 f_color)   (slide_image 0 0 x2 y2 "assembl(gaika-l)")
  (end_image)
)
;;;--------------------------------------------------------------------------
(defun im_b3 (f_color /)
  (setq	x2 (dimx_tile "b-3")   y2 (dimy_tile "b-3") )
  (start_image "b-3")
  (fill_image 0 0 x2 y2 f_color)   (slide_image 0 0 x2 y2 "assembl(vint)")
  (end_image)
)
;;;--------------------------------------------------------------------------
(defun im_b4 (f_color /)
  (setq	x2 (dimx_tile "b-4")   y2 (dimy_tile "b-4") )
  (start_image "b-4")
  (fill_image 0 0 x2 y2 f_color)   (slide_image 0 0 x2 y2 "assembl(gaikolp)")
  (end_image)
)
;;;--------------------------------------------------------------------------
(defun im_b5 (f_color /)
  (setq	x2 (dimx_tile "b-5")   y2 (dimy_tile "b-5") )
  (start_image "b-5")
  (fill_image 0 0 x2 y2 f_color)   (slide_image 0 0 x2 y2 "assembl(gaikont)")
  (end_image)
)
;;;--------------------------------------------------------------------------
(defun im_b6 (f_color /)
  (setq	x2 (dimx_tile "b-6")   y2 (dimy_tile "b-6") )
  (start_image "b-6")
  (fill_image 0 0 x2 y2 f_color)   (slide_image 0 0 x2 y2 "assembl(gaika-r)")
  (end_image)
)
;;;--------------------------------------------------------------------------

;;;--------------------------------------------------------------------------

;;;------------------> ASSEMBL <--------------------------------------
(defun c:assembl (/ $value
	            m_screw ;; 
	            b_1     ;;  1
	            b_2     ;;  2
                    b_3
                    b_4
                    b_5
                    b_6
                    b_7
                    rez  ugl
                    p_1 p_2 p_3 p_6
	      )

   (setq info_pr
	 (list
	   "             "
           "                         - "
           " _____________________________________________________ "
           " "
	   "   -  .  "
	   " 24  20001."
           "          Copyright  \"SingleSoft PG\" "
	   "                             mailto:gepos@mail.ru "
           " http://www.kulichki.com/cadhlp "
           " "
	  )
	
	;;-----   ----------------------------------------------------------------------------
	m_screw
	 (list "M3" "M4" "M5" "M6" "M8" "M10" "M12" "M14" "M16" "M18" "M20" "M22" "M24" "M27" "M30" "M33") 
        m_rez
	 (list "0.3" "0.4" "0.5" "0.6" "0.8" "1.0" "1.2" "1.4" "1.6" "1.8" "2.0" "2.2" "2.4" "2.7" "3.0" "3.3") 
	
        ;;-----   -------------------------------
	b_list
	 (list "b_1" "b_2" "b_3" "b_4" "b_5" "b_6" )
    )
	   
	
	
 ;;          
  (setq	ce  (getvar "CMDECHO")
	bm  (getvar "BLIPMODE")
	osm (getvar "OSMODE")
  )

  ;;  
  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 0)
  (setvar "OSMODE" 0)
  
 (setq 
        b_1 0     b_2 0      b_3 0    b_4 0     b_5 0      b_6 0
        p_1 0     p_2 0      p_3 0    p_6 0
        rez 0.3
  ) 
  ;;
  ;; open window functions 
  (setq DCL_ID (load_dialog "assembl.dcl"))
  (if (not (new_dialog "assembl01" dcl_id))
    (exit)
  )
  (im_b1 -15)
  (im_b2 -15)
  (im_b3 -15)
  (im_b4 -15)
  (im_b5 -15)
  (im_b6 -15)
  
  (start_list "m_screw" 3) (mapcar 'add_list m_screw)    (end_list)


  (action_tile "m_screw" "(setq rez (atof (nth (atoi $value) m_rez)))")



  (action_tile "b-1" "(cond 
                           ((= b_1 0) (im_b1 141)(im_b2 -15)(im_b3 -15)
                                      (setq b_1 1
                                            b_2 0
                                            b_3 0))
                           ((= b_1 1) (im_b1 -15)(setq b_1 0))
                       )
   ")
  (action_tile "b-2" "(cond 
                           ((= b_2 0) (im_b2 141)(im_b1 -15)(im_b3 -15)
                                      (setq b_2 1
                                            b_1 0
                                            b_3 0))
                           ((= b_2 1) (im_b2 -15)(setq b_2 0))
                       )
   ")
  (action_tile "b-3" "(cond 
                           ((= b_3 0) (im_b3 141)(im_b1 -15)(im_b2 -15)
                                      (setq b_3 1
                                            b_1 0
                                            b_2 0))
                           ((= b_3 1) (im_b3 -15)(setq b_3 0))
                       )
   ")
  (action_tile "b-4" "(cond 
                           ((= b_4 0) (im_b4 141)(im_b5 -15)(im_b6 -15)
                                      (setq b_4 1
                                            b_5 0
                                            b_6 0))
                           ((= b_4 1) (im_b4 -15)(setq b_4 0))
                       )
   ")
  (action_tile "b-5" "(cond 
                           ((= b_5 0) (im_b5 141)(im_b4 -15)(im_b6 -15)
                                      (setq b_5 1
                                            b_4 0
                                            b_6 0))
                           ((= b_5 1) (im_b5 -15)(setq b_5 0))
                       )
   ")
  (action_tile "b-6" "(cond 
                           ((= b_6 0) (im_b6 141)(im_b4 -15)(im_b5 -15)
                                      (setq b_6 1
                                            b_4 0
                                            b_5 0))
                           ((= b_6 1) (im_b6 -15)(setq b_6 0))
                       )
   ")
 

  (action_tile "info" "(ab_prog info_pr)")
  (action_tile "cancel" "(done_dialog 0)")
  (action_tile "accept" "(done_dialog 1)")


 ;;  Open calculation if OK- selected
 (if(= 1 (start_dialog))   ;; IF open
  (progn
         (setq p_1 (getpoint "\n     : ")
               p_6 (getpoint p_1 "\n    : ")
               ugl (/(* (+ (angle p_1 p_6) (/ pi 2.0)) 180.0) pi)
          )
;;---------------------------------------------------------------------------------
               (if (= b_1 1)
                   (progn

                   (command "INSERT" "_bolt.dwg" p_1 rez rez ugl)
                )  )     ;;  close IF,  PROGN
;;---------------------------------------------------------------------------------
               (if (= b_2 1)
                   (progn

                   (command "INSERT" "gaika-l.dwg" p_1 rez rez ugl)
                )  )     ;;  close IF,  PROGN
;;---------------------------------------------------------------------------------       
               (if (= b_3 1)
                   (progn

                   (command "INSERT" "vint.dwg" p_1 rez rez ugl)
                )  )     ;;  close IF,  PROGN
;;---------------------------------------------------------------------------------          
               (if (= b_4 1)
                   (progn
                   ;(setq p_6 (getpoint "\n  : "))
                   (command "INSERT" "gaikolp.dwg" p_6 rez rez ugl)
                )  )     ;;  close IF,  PROGN
;;---------------------------------------------------------------------------------
               (if (= b_5 1)
                   (progn
                   ;(setq p_6 (getpoint "\n  : "))
                   (command "INSERT" "gaikont.dwg" p_6 rez rez ugl)
                )  )     ;;  close IF,  PROGN
;;---------------------------------------------------------------------------------
               (if (= b_6 1)
                   (progn
                   ;(setq p_6 (getpoint "\n  : "))
                   (command "INSERT" "_gaika.dwg" p_6 rez rez ugl)
                )  )     ;;  close IF,  PROGN
         

;;---------------------------------------------------------------------------------
     (setq p_2 (polar p_1 (+ (angle p_1 p_6) (/ pi 2.0)) (/ rez 0.2))
           p_3 (polar p_6 (+ (angle p_1 p_6) (/ pi 2.0)) (/ rez 0.2))
      )
     (command "LINE" p_2 p_3 "")


     (setq p_2 (polar p_1 (- (angle p_1 p_6) (/ pi 2.0)) (/ rez 0.2))
           p_3 (polar p_6 (- (angle p_1 p_6) (/ pi 2.0)) (/ rez 0.2))
      )
     (command "LINE" p_2 p_3 "")

  ) ;; close PROGN
 )  ;; close IF START_DIALOG


; (print rez)

 ;;    
  (setvar "BLIPMODE" bm)
  (setvar "CMDECHO" ce)
  (setvar "OSMODE" osm)
  (princ)
)
;;;----------> END <-------------------------------------------------
;(c:assembl)